<?php
class plgHikashoppaymentAlphauserpoints extends JPlugin
{

	function onPaymentDisplay(&$order,&$methods,&$usable_methods){
		$api_AUP = JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php';
		if ( !(file_exists($api_AUP)))
			return true;
		$user=&Jfactory::getUser();
		if(empty($user->id)){
			return true;
		}
		if(!empty($methods)){
			foreach($methods as $i => $method){
				if($method->payment_type!='alphauserpoints' || !$method->enabled){
					continue;
				}

				//If partial payment isn't allowed and if the user don't have enought points to pay the full order -> AUP payment method isn't displayed
				if($this->getAUP())
					$userInfo=AlphaUserPointsHelper::getUserInfo( '', $user->id);
				if($methods[$i]->payment_params->partialpayment==0){
					if($this->checkPoints($order)===false){
						return true;
					}
				}

				// If the minimum cost isn't reach (calculated with or without shipping) -> AUP payment method isn't displayed
				if(!isset($order->full_total)){
					$total = $order->order_full_price;
					$total_without_shipping = $total-$order->order_shipping_price;
				}else{
					$total = $order->full_total->prices[0]->price_value_with_tax;
					$total_without_shipping = $order->total->prices[0]->price_value_with_tax;
				}
				if(@$methods[$i]->payment_params->minimumcost>$total){
					return true;
				}
				if(@$methods[$i]->payment_params->allowshipping==1){
					$calculatedPrice=$total;
				}else{
					$calculatedPrice=$total_without_shipping;
				}

				$neededpoints=($methods[$i]->payment_params->percent/100)*$calculatedPrice;
				$useablePoints=$this->pointsToCurrency($userInfo, $methods[$i]);
				if($useablePoints < $neededpoints){
					return true;
				}

				// If the user have no points or if he already have use his points to generate a coupon -> AUP payment method isn't displayed
				if(empty($userInfo->points))
					return true;
				if(!empty($order->coupon->discount_code)){
					if(preg_match('#^POINTS_[a-zA-Z0-9]{30}$#',$order->coupon->discount_code)){
						return true;
					}
				}
				if($methods[$i]->payment_params->partialpayment==0){
					$methods[$i]->payment_params->percentmax=100;
				}

				//If the percentage max is 0, you can never pay with points;
				if($methods[$i]->payment_params->percentmax<=0){
					return true;
				}

				//Check zone and currency
				if(!empty($method->payment_zone_namekey)){
					$zoneClass=hikashop_get('class.zone');
					$zones = $zoneClass->getOrderZones($order);
					if(!in_array($method->payment_zone_namekey,$zones)){
						return true;
					}
				}

				$config =& hikashop_config();
				$this->main_currency = $config->get('main_currency',1);
				$currencyClass = hikashop_get('class.currency');
				$currency = hikashop_getCurrency();
				$this->currency = $currencyClass->get($this->main_currency);

				//convertion if currencies are not the same
				if($this->main_currency!=$currency){
					$method->payment_params->value=$currencyClass->convertUniquePrice($method->payment_params->value,$this->main_currency,$currency);
					$method->payment_params->minimumcost=$currencyClass->convertUniquePrice($method->payment_params->minimumcost,$this->main_currency,$currency);
					$method->payment_params->currency_rate=$currencyClass->convertUniquePrice($method->payment_params->currency_rate,$this->main_currency,$currency);
				}
				if(isset($order->order_currency_id)){
					$curr = $order->order_currency_id;
				}else{
					$curr = hikashop_getCurrency();
				}
				$price=$currencyClass->format($this->pointsToCurrency($userInfo, $methods[$i], $order),$curr);

				$method->payment_description.=JText::sprintf( 'YOU_HAVE',$userInfo->points, $price);

				// Change the displayed message for the payment method
				if($methods[$i]->payment_params->partialpayment == 0 ) {
					if( $method->payment_params->allowshipping == 1 ) {
						$method->payment_description.=JText::sprintf( 'PAY_FULL_ORDER_POINTS', $this->finalPriceToPoints($order, $userInfo, $methods[$i]));
					} else {
						$method->payment_description.=JText::sprintf( 'PAY_FULL_ORDER_NO_SHIPPING',$this->finalPriceToPoints($order, $userInfo, $methods[$i]));
						$method->payment_description.=JText::sprintf( 'COUPON_GENERATE' );
						$method->payment_description.=JText::sprintf( 'CAUTION_POINTS' );
					}
				} else {
					$check = $this->checkPoints($order);
					if( $check !== false ) {
						if( $methods[$i]->payment_params->percentmax >= 100) {
							$method->payment_description.=JText::sprintf( 'PAY_FULL_ORDER_POINTS', $this->finalPriceToPoints($order, $userInfo, $methods[$i]) );
						} else if( $methods[$i]->payment_params->percentmax < 100 && $methods[$i]->payment_params->percentmax > 0 ) {
							$coupon = $check * $methods[$i]->payment_params->value;
							$price = $currencyClass->format($coupon ,$this->currency->currency_id);
							$method->payment_description .= JText::sprintf( 'COUPON_GENERATE_PARTIAL', $price);
							$method->payment_description .= JText::sprintf( 'CAUTION_POINTS' );
						}
					} else {
						$coupon = $userInfo->points * $methods[$i]->payment_params->value;
						$price = $currencyClass->format($coupon, $this->currency->currency_id);
						$method->payment_description .= JText::sprintf( 'COUPON_GENERATE_PARTIAL', $price );
						$method->payment_description .= JText::sprintf( 'CAUTION_POINTS' );
					}
				}

				$usable_methods[$method->ordering]=$method;
			}
		}
		return true;
	}

	//return how much you can pay with your points
	function pointsToCurrency(&$userInfo, &$method){
		$coupon = @$userInfo->points * @$method->payment_params->value;
		return $coupon;
	}

	//return the number of points if the user can pay the final price only with points. If not, return false
	function checkPoints(&$order){
		$method = $this->getMethod();
		$user =& Jfactory::getUser();
		if(empty($user->id)) {
			return true;
		}

		if($this->getAUP()) {
			$userInfo = AlphaUserPointsHelper::getUserInfo('', $user->id);
		}
		$points = $this->finalPriceToPoints($order, $userInfo, $method);

		// Partial payment
		if( !empty($method->payment_params->percentmax) && $method->payment_params->partialpayment == 1) {
			$points = $points * ( $method->payment_params->percentmax / 100 );
		}

		// If user has less points, we use his stock value.
		if( (int)$userInfo->points < $points ) {
			$points = (int)$userInfo->points;
		}

		// Group points
		if( isset($method->payment_params->grouppoints) && ((int)$method->payment_params->grouppoints > 1) ) {
			$points -= ($points % (int)$method->payment_params->grouppoints);
		}

		// Check maximum points
		if(isset($method->payment_params->maxpoints) && ((int)$method->payment_params->maxpoints > 0) && $points > (int)$method->payment_params->maxpoints) {
			$points = (int)$method->payment_params->maxpoints;

			// Re-Group points
			if( isset($method->payment_params->grouppoints) && ((int)$method->payment_params->grouppoints > 1) ) {
				$points -= ($points % (int)$method->payment_params->grouppoints);
			}
		}

		if( $points < $userInfo->points )
			return $points;
		return false;
	}

	function onPaymentSave(&$cart,&$rates,&$payment_id){
		$usable = array();
		$this->onPaymentDisplay($cart,$rates,$usable);
		$payment_id = (int) $payment_id;
		foreach($usable as $usable_method){
			if($usable_method->payment_id==$payment_id){
				return $usable_method;
			}
		}
		return false;
	}

	//return the number of points you have to use to pay the full order
	function finalPriceToPoints(&$order, &$userInfo, &$method){
		if(empty($order->cart->full_total->prices[0]->price_value_with_tax)){
			if($method->payment_params->allowshipping == 1){
				$final_price = @$order->full_total->prices[0]->price_value_with_tax;
			}else{
				$final_price = @$order->total->prices[0]->price_value_with_tax;
			}
		}else{
			 if($method->payment_params->allowshipping == 1){
				$final_price = @$order->cart->full_total->prices[0]->price_value_with_tax;
			 }else{
				$final_price = @$order->cart->total->prices[0]->price_value_with_tax;
			 }
		}

		$pointsDecrease = $final_price * ( 1 / $method->payment_params->value );
		return round($pointsDecrease, 0);
	}

	//give points earned with an order
	function getPointsEarned($order){
		$method=$this->getMethod();
		$points=0;
		$database =& JFactory::getDBO();

		$config =& hikashop_config();
		$this->main_currency = $config->get('main_currency',1);
		$currencyClass = hikashop_get('class.currency');
		$this->currency = $currencyClass->get($this->main_currency);

		//convertion if currencies are not the same
		if($this->main_currency!=$order->order_currency_id){
			$method->payment_params->value=$currencyClass->convertUniquePrice($method->payment_params->value,$this->main_currency,$order->order_currency_id);
			$method->payment_params->minimumcost=$currencyClass->convertUniquePrice($method->payment_params->minimumcost,$this->main_currency,$order->order_currency_id);
			$method->payment_params->currency_rate=$currencyClass->convertUniquePrice($method->payment_params->currency_rate,$this->main_currency,$order->order_currency_id);
		}

		//give point for a special category
		$categories=unserialize($method->payment_params->categories);
		if(!empty($categories)){
			if(!empty($order->cart->products)){
				$products=&$order->cart->products;
			}else{
				$products=&$order->products;
			}
			foreach ($products as $product){
				$ids[$product->product_id]=$product->product_id;
			}
			$queryP='SELECT product_parent_id FROM '.hikashop_table('product').' WHERE product_id IN ('.implode(',',$ids).')';
			$database->setQuery($queryP);
			$pids = $database->loadObjectList();
			if(!empty($pids)){
				foreach ($pids as $pid){
					$ids[$pid->product_parent_id]=$pid->product_parent_id;
				}
			}

			$query='SELECT * FROM '.hikashop_table('product_category').' prod LEFT JOIN '.hikashop_table('category').' cat ON prod.category_id=cat.category_id ' .
					'WHERE prod.product_id IN ('.implode(',',$ids).')';
			$database->setQuery($query);
			$idcats = $database->loadObjectList();
			if(!empty($idcats)){
				$query='SELECT * FROM '.hikashop_table('category').' WHERE category_type=\'product\' AND ';
				$conditions = array();
				foreach ($idcats as $idcat){
					$conditions[]='(category_left <= '.$idcat->category_left.' AND category_right >= '.$idcat->category_right.')';
					$idfinalcats[$idcat->product_id][0][]=$idcat->category_id;
				}
				$query.=implode(' OR ',$conditions);
			}
			$database->setQuery($query);
			$idparentcats = $database->loadObjectList('category_id');
			foreach ($idcats as $id){
				$this->_makeLevel($idfinalcats[$id->product_id],0,$idparentcats);
			}

			$maxPoints=0;
			$tempCatId=null;
			foreach($idfinalcats as $product){
				foreach($product as $levels){
					foreach($categories as $category){
						foreach ($levels as $categoryid){
							if($categoryid==$category->category_id && $category->category_points>$maxPoints){
								$maxPoints=$category->category_points;
								$tempCatId=$category->category_id;
							}
						}
						$points+=$maxPoints;
						if(!empty($tempCatId)){
							foreach ($categories as $category){
								if($category->category_id==$tempCatId && $method->payment_params->limitecategory==1){
									$category->category_points=0;
								}
							}
							$maxPoints=0;
							$tempCatId=0;
							break 2;
						}
						$maxPoints=0;
					}
				}
			}
		}

		//give points for the user group. Ueable on create and on update
		if(hikashop_level(2)){
			$groups=unserialize($method->payment_params->groups);
			if(!empty($order->customer->user_cms_id)){
				$gid = $order->customer->gid;
			}else{
				$my =& JFactory::getUser();
				$gid = $my->gid;
			}
			if(version_compare(JVERSION,'1.6.0','<')){
				if(empty($gid)){
					$userGroups = array(29); // default group in J1.5
				}else{
					$userGroups = array($gid);
				}
			}else{
				jimport('joomla.access.access');
				$userGroups = JAccess::getGroupsByUser($gid, true);//$my->authorisedLevels();
			}

			foreach($userGroups as $groupid){
				if(!empty($groups[$groupid])){
					$points+=$groups[$groupid];
				}
				if(!empty($groups[$groupid]) && $method->payment_params->limitegroup==1){
					break;
				}
			}
		}

		//give points on the final order price, with or without shipping, for one or each product. Ueable on create and on update
		if(!empty($order->cart->full_total->prices[0]->price_value_with_tax)){
			if($method->payment_params->shippingpoints==1){
				$calculatedPrice = $order->cart->full_total->prices[0]->price_value_with_tax - @$order->cart->coupon->discount_value;
			}else{
				$calculatedPrice = $order->cart->total->prices[0]->price_value_with_tax - @$order->cart->coupon->discount_value;
			}
		}else{
			if($method->payment_params->shippingpoints==1){
				$calculatedPrice = $order->order_full_price - $order->order_discount_price;
			}else{
				$calculatedPrice = $order->order_full_price - $order->order_discount_price - $order->order_shipping_price;
			}
		}

		if($method->payment_params->currency_rate!=0){
			$points += $calculatedPrice/$method->payment_params->currency_rate;
		}

		if(!empty($order->cart->products)){
			$products = &$order->cart->products;
		}else{
			$products = &$order->products;
		}

		if($method->payment_params->limitetype==1){
			foreach ($products as $product){
				$points += $method->payment_params->productpoints;
			}
		}elseif($method->payment_params->limitetype == 0){
			foreach ($products as $product){
				$points += $method->payment_params->productpoints*$product->order_product_quantity;
			}
		}
		return $points;
	}

	function _makeLevel(&$productData,$level,&$idparentcats){
		foreach($productData[$level] as $cat){
			if(!empty($idparentcats[$cat]->category_parent_id) && !empty($idparentcats[$idparentcats[$cat]->category_parent_id])){
				$productData[$level+1][] = $idparentcats[$cat]->category_parent_id;
			}
		}
		if(!empty($productData[$level+1])){
			$this->_makeLevel($productData,$level+1,$idparentcats);
		}
	}

	function getAUP(){
		static $aup=null;
		if(!isset($aup)){
			$aup=false;
			$api_AUP = JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php';
			if(file_exists($api_AUP)){
				require_once ($api_AUP);
				if(class_exists('AlphaUserPointsHelper')){
					$aup=true;
				}
			}
			if(!$aup){
				$app =& JFactory::getApplication();
				if($app->isAdmin()){
					$app->enqueueMessage('The HikaShop AlphaUserPoints plugin requires the component AlphaUserPoints to be installed. If you want to use it, please install the component.');
				}
			}
		}
		return $aup;
	}

	function onPaymentConfiguration(&$element){
	 	$api_AUP = JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php';
		if ( !(file_exists($api_AUP))){
			$app =& JFactory::getApplication();
			$app->enqueueMessage('You have to install the AlphaUserPoint component in order to use this payment method', 'error');
			$link=hikashop::completeLink("plugins&plugin_type=payment",false, true);
			$app->redirect($link);
			return true;
		}
		$db = &JFactory::getDBO();
		$query='SELECT id FROM '.hikashop::table('alpha_userpoints_rules',false).' WHERE rule_name="Order_validation"';
		$db->setQuery($query);
		$exist=$db->loadResult();
		if(empty($exist)){
			$query='INSERT INTO '.hikashop::table('alpha_userpoints_rules',false).' (rule_name, rule_description, rule_plugin, plugin_function, access, points, published, system, autoapproved)' .
					'VALUES ("Order_validation", "Give points to customer when the order is validate", "com_hikashop", "plgaup_orderValidation", 1, 0, 1, 0,1)';
			$db->setQuery($query);
			$db->query();
		}
		$subtask = JRequest::getCmd('subtask','');
		$this->alphauserpoints = JRequest::getCmd('name','alphauserpoints');
		$this->getAUP();
		if(empty($element)){
			$element = null;
			$element->payment_name='Pay with Points';
			$element->payment_description='You can pay with points using this payment method';
			$element->payment_images='';
			$element->payment_type=$this->alphauserpoints;
			$element->payment_params=null;
			$element->payment_params->invalid_status='cancelled';
			$element->payment_params->pending_status='created';
			$element->payment_params->verified_status='confirmed';
			$element->payment_params->percentmax=100;
			$element = array($element);
		}
		$bar = & JToolBar::getInstance('toolbar');
		JToolBarHelper::save();
		JToolBarHelper::apply();
		JToolBarHelper::cancel();
		JToolBarHelper::divider();
		$bar->appendButton( 'Pophelp','payment-alphauserpoints-form');
		hikashop_setTitle('AlphaUserPoints','plugin','plugins&plugin_type=payment&task=edit&name='.$this->alphauserpoints);
		$this->address = hikashop_get('type.address');
		$this->category = hikashop_get('type.categorysub');
		$this->category->type = 'status';
		$this->categories = array();
		$key = key($element);
		if(!empty($element[$key]->payment_params->categories)){
			$this->categories = unserialize($element[$key]->payment_params->categories);
		}
		$ids = array();
		if(!empty($this->categories)){
			foreach($this->categories as $cat){
				$ids[]=$cat->category_id;
			}
			$db =& JFactory::getDBO();
			$db->setQuery('SELECT * FROM '.hikashop_table('category').' WHERE category_id IN ('.implode(',',$ids).')');
			$cats = $db->loadObjectList('category_id');
			foreach($this->categories as $k => $cat){
				if(!empty($cats[$cat->category_id])){
					$this->categories[$k]->category_name = $cats[$cat->category_id]->category_name;
				}else{
					$this->categories[$k]->category_name = JText::_('CATEGORY_NOT_FOUND');
				}
			}
		}

		$acl =& JFactory::getACL();
		if(version_compare(JVERSION,'1.6.0','<')){
			$this->groups = $acl->get_group_children_tree( null, 'USERS', false );
		}else{
			$db = JFactory::getDBO();
			$db->setQuery('SELECT a.*, a.title as text, a.id as value  FROM #__usergroups AS a ORDER BY a.lft ASC');
			$this->groups = $db->loadObjectList('id');
			foreach($this->groups as $id => $group){
				if(isset($this->groups[$group->parent_id])){
					$this->groups[$id]->level = intval(@$this->groups[$group->parent_id]->level) + 1;
					$this->groups[$id]->text = str_repeat('- - ',$this->groups[$id]->level).$this->groups[$id]->text;
				}
			}
		}

		if(!empty($element[$key]->payment_params->groups)){
			$element[$key]->payment_params->groups = unserialize($element[$key]->payment_params->groups);
			foreach($this->groups as $id => $group){
				$this->groups[$id]->points = (int)@$element[$key]->payment_params->groups[$group->value];
			}
	 	}

		$config =& hikashop_config();
		$this->main_currency = $config->get('main_currency',1);
		$currency = hikashop_get('class.currency');
		$this->currency = $currency->get($this->main_currency);


		$js='
function setVisible(value){
	value = (parseInt(value) == 1) ? "" : "none";
	document.getElementById("opt").style.display = value;
	document.getElementById("opt2").style.display = value;
}
';
		$doc =& JFactory::getDocument();
		$doc->addScriptDeclaration($js);
	}

	function onPaymentConfigurationSave(&$element){
		$categories = JRequest::getVar( 'category', array(), '', 'array' );
		JArrayHelper::toInteger($categories);
		$cats = array();
		if(!empty($categories)){
			foreach($categories as $id => $category){
				if((int)@$_REQUEST['category_points'][$id]!=0){
					$obj = null;
					$obj->category_id = $category;
					$obj->category_points = (int)@$_REQUEST['category_points'][$id];
					$cats[]=$obj;
				}
			}
		}
		$element->payment_params->categories = serialize($cats);
		$groups = JRequest::getVar( 'groups', array(), '', 'array' );
		JArrayHelper::toInteger($groups);
		$element->payment_params->groups = serialize($groups);
	}

	// Give the parameters of AUP
	function getMethod(){
		$db =& JFactory::getDBO();
		$query = 'SELECT * FROM '.hikashop_table('payment').' WHERE payment_type=\'alphauserpoints\'';
		$db->setQuery($query);
		$paymentData = $db->loadObject();
		$paymentData->payment_params = unserialize($paymentData->payment_params);
		return $paymentData;
	}

	function onAfterOrderConfirm(&$order,&$methods,$method_id){
		$this->removeCart = true;
	}

	function onBeforeOrderCreate(&$order,&$do){
		$method=$this->getMethod();
		if(!empty($order->cart->coupon->discount_code)){
			if(preg_match('#^POINTS_[a-zA-Z0-9]{30}$#',$order->cart->coupon->discount_code)){
				if($method->payment_params->partialpayment==0){
					if($order->cart->full_total->prices[0]->price_value_without_discount!=$order->cart->coupon->discount_value){
						$do=false;
						echo JText::sprintf( 'ERROR_POINTS' );
						return true;
					}
				}
			}
		}
		if($order->order_payment_method!='alphauserpoints'){
			return true;
		}
		$check=$this->checkPoints($order);
		$user=&Jfactory::getUser();
		if($this->getAUP())
			$userInfo=AlphaUserPointsHelper::getUserInfo( '', $user->id);

		// Generate a coupon for a partial payment
		if($method->payment_type=='alphauserpoints' && ($method->payment_params->partialpayment==1 || $method->payment_params->allowshipping==0) && $check===false && $userInfo->points){
			$discountClass = hikashop_get('class.discount');
			$obj=&hikashop_get('class.cart');
			$config =& hikashop_config();
	 		$currency = hikashop_getCurrency();

			$app=&JFactory::getApplication();
			$newCoupon = null;
			$newCoupon->discount_type='coupon';
			$newCoupon->discount_currency_id = $currency;

			$newCoupon->discount_flat_amount = $userInfo->points*$method->payment_params->value;
			$newCoupon->discount_quota = 1;
			jimport('joomla.user.helper');
			$newCoupon->discount_code = 'POINTS_';
			$newCoupon->discount_code .= JUserHelper::genRandomPassword(30);
			$newCoupon->discount_published = 1;
			$discountClass->save($newCoupon);
			$coupon = $newCoupon;
			if(!empty($coupon)){
				$obj->update($coupon->discount_code,1,0,'coupon');
			}
			$app->setUserState( HIKASHOP_COMPONENT.'.payment_method','');
			$app->setUserState( HIKASHOP_COMPONENT.'.payment_id',0);
			$app->setUserState( HIKASHOP_COMPONENT.'.payment_data',0);
			$do=false;
			if($this->getAUP()){
				if(empty($order->customer)){
					$userClass = hikashop_get('class.user');
					$order->customer = $userClass->get($order->order_user_id);
				}
				$aupid=AlphaUserPointsHelper::getAnyUserReferreID($order->customer->user_cms_id);
				AlphaUserPointsHelper::newpoints( 'plgaup_orderValidation', $aupid, '', '', -$check);
			}
		}
	}

	function onAfterOrderCreate(&$order,&$send_email){
		$app =& JFactory::getApplication();
		if($app->isAdmin()) {
			return true;
		}
		$method=$order->order_payment_method;
		// Decrease points used by an user to pay a full order
		if($method=='alphauserpoints'){
			$points=$this->checkPoints($order);
			if($points!==false){
				if($this->getAUP()){
					if(empty($order->customer)){
						$userClass = hikashop_get('class.user');
						$order->customer = $userClass->get($order->order_user_id);
					}
					$aupid=AlphaUserPointsHelper::getAnyUserReferreID($order->customer->user_cms_id);
					AlphaUserPointsHelper::newpoints( 'plgaup_orderValidation', $aupid, '', '', -$points);
				}
				$orderObj = null;
				$config =& hikashop_config();
				$orderObj->order_status = $config->get('order_confirmed_status');
				$orderObj->order_id = $order->order_id;
				$orderClass = hikashop_get('class.order');
				$orderClass->save($orderObj);
			}else{
				echo JText::sprintf( 'NOT_ENOUGH_POINTS' );
				$do=false;
				return false;
			}
		}
	}

	function onBeforeOrderUpdate(&$order,&$do){
		$previousOrder=&hikashop_get('class.order');
		$previousOrder=$previousOrder->get($order->order_id);
		$this->previousOrderStatus=$previousOrder->order_status;
	}

	function onAfterOrderUpdate(&$order,&$send_email){
		$method=$this->getMethod();
		if(!isset($order->order_status)) return true;
		$classOrder=&hikashop_get('class.order');
		$fullOrder=$classOrder->loadFullOrder($order->order_id, false, false);
		if(empty($fullOrder->customer)){
			$userClass = hikashop_get('class.user');
			$fullOrder->customer = $userClass->get($fullOrder->order_user_id);
		}
		$config=&hikashop_config();
		$confirmed = $config->get('order_confirmed_status');
		// Give points earned on an order
		if($order->order_status==$confirmed){
			$points=$this->getPointsEarned($fullOrder);
			$userid=(int) $fullOrder->customer->user_cms_id;
			if($this->getAUP()){
				$aupid=AlphaUserPointsHelper::getAnyUserReferreID($userid);
				AlphaUserPointsHelper::newpoints( 'plgaup_orderValidation', $aupid, '', '', $points);
			}
		}

		$cancelled = $config->get('cancelled_order_status');
		$prev=0;
		$cancelled=explode(',',$cancelled);
		foreach ($cancelled as $can){
			if($order->order_status==$can){
				$prev=1;
			}
		}

		// Give back points to an user if the order is cancelled (the previous status have to be 'confirmed')
		if($prev==1 && in_array($this->previousOrderStatus,array($confirmed,'shipped'))){

			if($fullOrder->order_payment_method=='alphauserpoints' && $method->payment_params->givebackpoints==1){
				$userid=(int) $fullOrder->customer->user_cms_id;
				if($this->getAUP()){
					$aupid=AlphaUserPointsHelper::getAnyUserReferreID($userid);
					AlphaUserPointsHelper::newpoints( 'plgaup_orderValidation', $aupid, '', '', $fullOrder->order_full_price*$method->payment_params->currency_rate);
				}
				return true;
			}
			if(!empty($fullOrder->order_discount_code)){
				if(preg_match('#^POINTS_[a-zA-Z0-9]{30}$#',$fullOrder->order_discount_code) && $method->payment_params->givebackpoints==1){
					$userid=(int) $fullOrder->customer->user_cms_id;
					if($this->getAUP()){
						$aupid=AlphaUserPointsHelper::getAnyUserReferreID($userid);
						AlphaUserPointsHelper::newpoints( 'plgaup_orderValidation', $aupid, '', '', $fullOrder->order_discount_price*$method->payment_params->currency_rate);
					}
				}
			}
			$points=$this->getPointsEarned($fullOrder);
			$points=round($points);
			$userid=(int) $fullOrder->customer->user_cms_id;
			if($this->getAUP()){
				$aupid=AlphaUserPointsHelper::getAnyUserReferreID($userid);
				AlphaUserPointsHelper::newpoints( 'plgaup_orderValidation', $aupid, '', '', -$points);
			}
		}
	}
}
